/*
 * Mainboard_UART_functions.h
 *
 * Created: 21.01.2014 10:19:10
 *  Author: Alex
 */ 


#ifndef Mainboard_UART_functions_H_
#define Mainboard_UART_functions_H_

#include <avr/io.h>
#include <stdbool.h>

typedef struct config{
	bool start_flag;
	bool empty_buf_flag;
	bool running_flag;
	bool config_flag;
	bool bt_flag;
	bool speedmode;
	bool temp_flag;
	bool conf_matrix [4][4];
	char conf_list[17];
	uint8_t conf_cnter;
	uint8_t active_ch;
	bool active_lambda;
	uint8_t active_mod;
}conf_stat;

typedef struct info{
	uint8_t active_ch;
	uint8_t active_mod;
	bool lambda;
	bool temp;
	bool speedmode;
	}meas_info;

void ADC_handler(uint8_t adcval, uint8_t triggerlevel, bool *adctoggle);
void ADC_init();
void ADC_disable();	
void ADC_enable();
uint8_t ADC_get_value();	
uint16_t ADC_gettwobytevalue();

void LED2_on();
void LED2_off();

void Bluetooth_Reset();

void channel_administrator (conf_stat *conf, meas_info *info);
void process_rxbuf (unsigned int c, uint16_t *timer_ms_counter, conf_stat *config);

void NIRS_module_trigger (uint8_t module);
void NIRS_module_deactivate(uint8_t module);
void NIRS_module_set_channel (uint8_t module, uint8_t channel);
void NIRS_module_reset(uint8_t module);

uint16_t generate_configuration (conf_stat *config);

void send_ADC_raw (uint32_t adcreceive);
void send_ADC_temp (uint16_t temp);
void send_ADC_data (uint8_t active_module, uint8_t active_channel, bool lambda, bool Speedmode, uint16_t adc_value, uint16_t timestamp);

void Timer_init();
void Timer_reset(uint16_t *timer_ms_counter);
void Timer_disable_interrupt();
void Timer_enable_interrupt();



#endif /* Mainboard_UART_functions_H_ */